/*$Id: fkByteArrayInputStream.h,v 1.3 2008/05/18 10:29:00 jwrobel Exp $*/

/* ***** BEGIN LICENSE BLOCK *****
 *  This file is part of Firekeeper.
 *
 *  The Original Code is Mozilla Communicator client code, released
 *  March 31, 1998.
 *
 *  The Initial Developer of the Original Code is
 *  Netscape Communications Corporation.
 *  Portions created by the Initial Developer are Copyright (C) 1998-1999
 *  the Initial Developer. All Rights Reserved.
 *
 *  Copyright (C) 2008 Wrobel <wrobel@blues.ath.cx> (Firekeeper version)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * ***** END LICENSE BLOCK ***** */


/*
 * This file was taken directly from Mozilla's nsByteArrayInpurtStream.
 * Firefox from version 3.0 is not shipped with lib_xpcom_core
 * which includes this class. To support FF 3.0 Firekeeper
 * has to include its own implementation of ByteArrayInpurtStream.
 */
#include "nsIInputStream.h"
#include "nsCOMPtr.h"

class fkByteArrayInputStream : public nsIInputStream
{
    // nsISupports methods
    NS_DECL_ISUPPORTS

    // nsIInputStream methods
    NS_DECL_NSIINPUTSTREAM
    
public:
    fkByteArrayInputStream (char *buffer, PRUint32 nbytes);

private:
    ~fkByteArrayInputStream ();

    char        *_buffer;
    PRUint32     _nbytes;
    PRUint32     _pos;
};


NS_IMETHODIMP 
FK_NewByteArrayInputStream(nsIInputStream **aResult, 
			   char * buffer, unsigned long bytes);
